;//////////////////////////////////////////////////////////////////////////
;WinFire by Del Nero Jean Franois  (Email:jeanfrancoisdelnero@libero.it) /
;//////////////////////////////////////////////////////////////////////////
.486p
.MODEL FLAT,STDCALL


OPTION SCOPED        
                     
OPTION CASEMAP:NONE  


include \MASM32\include\windows.inc

include \MASM32\include\kernel32.inc
include \MASM32\include\user32.inc
include \MASM32\include\gdi32.inc

includelib \MASM32\LIB\kernel32.lib
includelib \MASM32\LIB\user32.lib
includelib \MASM32\LIB\gdi32.lib

SCREEN_WIDTH=320
SCREEN_HEIGHT=200
;Pile pour le  nouveau thread
MAIN_THREAD_STACKSIZE_KB=16


.DATA?
 ALIGN 4
 ;Buffer `video`
 FrameBuffer db SCREEN_WIDTH*SCREEN_HEIGHT+512 dup (?)
 seed1 dw ?
 seed2 dw ?
 EscapePressed DD ?
 MainThreadHandle DD ?
 myDC HDC ?



.DATA
MyClassName db 'HxCClass',0        ;  class name
WinTitleString db '<Power Of Asm> <HxC>',0 ; Titre
 constant  dw	 8405h		       ;multiplier value
 MsgCaption      db "Keys :",0
 MsgBoxText      db "C , V , B and N...",13,10
 				 db "Et a Bientot sur :",13,10
                 db "http://digilander.iol.it/jeanfrancoisdelnero/",10,13
                 db "Email :jeanfrancoisdelnero@libero.it",13,10,0
  

dibinf LABEL BITMAPINFO
BITMAPINFOHEADER < \ ;
 sizeof BITMAPINFOHEADER, \ ;biSize
 SCREEN_WIDTH,            \ ;biWidth
 -SCREEN_HEIGHT,          \ ;biHeight
 1,                       \ ;biPlanes
 8,                       \ ;biBitCount
 BI_RGB,                  \ ;biCompression
 0,                       \ ;biSizeImage
 0,                       \ ;biXPelsPerMeter
 0,                       \ ;biYPelsPerMeter
 0,                       \ ;biClrUsed
 0>                         ;biClrImportant
Win_Palette RGBQUAD 256 dup (<>) ; RGB + reserved = 4 bytes


 ALIGN 4
 nbfoyer db 40
 hot db 255
 
 
;**********************************************************************************************
.CODE
    
CalcPalette PROC
 COLORSCALE=100h ; 8bit par couleur (RVB)
 mov edi,OFFSET Win_Palette
 
 ;BGRx for Win
  
mov cl,64
xor al,al
bouclecouleur1:

push ax
dec cl
mov al,cl
shl al,2
stosb
xor al,al
stosb
stosb
pop ax
inc edi
inc al
cmp al,64
jne bouclecouleur1

xor al,al
bouclecouleur2:
push ax
XOR AL,AL
stosb
stosb
pop ax
push ax
shl al,2
stosb
pop ax
inc edi
inc al
cmp al,64
jne bouclecouleur2


xor al,al
bouclecouleur3:
mov bl,al
xor al,al
stosb

mov al,bl
shl al,2
stosb
mov al,255
stosb

mov al,bl
inc edi
inc al
cmp al,64
jne bouclecouleur3

xor al,al
bouclecouleur4:
push ax
shl al,2
stosb
mov al,255
stosb
stosb
pop ax
inc edi
inc al
cmp al,64
jne bouclecouleur4

ret
CalcPalette ENDP


ALIGN 4 ;====================================================================
Render PROC  ;procedure effet flamme
 pushad

mov cL,ds:[nbfoyer]
@@bouclerandom:
mov esi,offset FrameBuffer + 320*200- 320
xor eax,eax
mov ax,320
call randomgenerator
and eax,0fffh
add esi,eax
mov bl,ds:[hot]
mov bh,7
;add esi,1;eax
@@eer:
mov es:[esi],bl
add esi,1
mov es:[esi],bl
sub esi,2
dec bh
jnz @@eer
dec cl
jnz @@bouclerandom

MOV EDI,offset FrameBuffer
@@somme1:
add Edi,319
MOV AX,eS:[EDI]

mov bl,ah

add Edi,2

MOV cl,eS:[EDI]

add Edi,319
MOV dl,eS:[EDI]

xor ah,ah
mov bh,ah
mov ch,ah
mov dh,ah

add ax,bx
add ax,cx
add ax,dx

sub Edi,640 

shr ax,2

mov es:[Edi],al
 
inc Edi
cmp EDI,320*200 + Offset FrameBuffer
jne @@somme1


 popad
 ret
Render ENDP

;*************************************************************************
randomgenerator proc
 push edx
 push ebx	
 push ecx
    push	 ax		       ;save the range value
	  mov	 ax,ds:[seed1]
	  mov	 bx,ds:[seed2]	       ;load seeds
	  mov	 cx,ax		       ;save seed
	  mul	 ds:[constant]	       ;(dx,ax) = ax * constant
	  shl	 cx,1
	  shl	 cx,1
	  shl	 cx,1
	  add	 ch,cl
	  add	 dx,cx
	  add	 dx,bx
	  shl	 bx,1		       ;begin scramble algorithm
	  shl	 bx,1
	  add	 dx,bx
	  add	 dh,bl
	  mov	 cl,5
	  shl	 bx,cl
	  add	 ax,1
	  adc	 dx,0
	  mov	 ds:[seed1],ax
	  mov	 ds:[seed2],dx	       ;save results as the new seeds
	  pop	 bx		       ;get back range value
	  xor	 ax,ax		       ;clear register
	  xchg	 ax,dx		       ;adjust ordering
	  div	 bx		       ;ax = trunc((dx,ax) / bx), dx = (r)
	  xchg	 ax,dx		       ;return remainder as the random number
 pop ecx
 pop ebx
 pop edx
 ret
randomgenerator endp

;*************************************************************************
; code Windows

;///////////Copie dans la fenetre
DIB_Draw PROC hWnd:HWND
LOCAL myRect:RECT
 invoke GetClientRect,hWnd,ADDR myRect
 mov edx,0
 invoke StretchDIBits,myDC,edx,edx,
                      myRect.right,
                      myRect.bottom,
                      edx,edx,
                      SCREEN_WIDTH,
                      SCREEN_HEIGHT,
                      OFFSET FrameBuffer,
                      ADDR dibinf,
                      edx,        ;DIB_RGB_COLORS=0
                      SRCCOPY
 ret
DIB_Draw ENDP


ALIGN 4
;/////////////////////Tread principal
MainLoopProc PROC hWnd:DWORD
LOCAL hProc:HANDLE
 invoke GetDC,hWnd
 mov myDC,eax
 
  mov ds:[seed1],ax
  mov ds:[seed2],bx	 
 
 invoke GetCurrentProcess
 mov hProc,eax

@@forever:
 test byte ptr [EscapePressed],0FFh ; ESC ?
 jnz @@exit

 pushad
 call Render               ;traitement
 popad

 push hWnd
 call DIB_Draw          ;/copie dans fenetre

 jmp @@forever

@@exit:
 invoke ReleaseDC,hWnd,myDC ;
 invoke PostMessage,hWnd,WM_CLOSE,NULL,NULL
 ret
MainLoopProc ENDP


ALIGN 4

;////////////Procedure de traitement des messages\\\\\\\\\\\\\\\\\\\\\\\\\\\
MainWinProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
 mov eax,uMsg
  .if eax==WM_CREATE
   call CalcPalette
   invoke CreateThread,NULL,MAIN_THREAD_STACKSIZE_KB*1024,ADDR MainLoopProc,hWnd,NULL,ADDR MainThreadHandle
  .elseif eax==WM_KEYDOWN
    cmp wParam,VK_ESCAPE
    setz al
    mov byte ptr [EscapePressed],al
 	 cmp wParam,VK_C
 	 jne suite123
 	  inc ds:[nbfoyer] 	 
 	 suite123:
 	 cmp wParam,VK_V
 	 jne suite124
 	  dec ds:[nbfoyer]
 	 suite124:
 	 cmp wParam,VK_B
 	 jne suite125
 	  inc ds:[hot]
 	 suite125:
 	 cmp wParam,VK_N
 	 jne suite126
      dec ds:[hot] 	 
 	 suite126:
  .elseif eax==WM_DESTROY
    invoke PostQuitMessage,0
  .else
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
  .endif
 ret
MainWinProc ENDP



;//////////////////////////Debut du Programme\\\\\\\\\\\\\\\\\\\\\\\\\\
ALIGN 4
WinMain PROC hInst:DWORD,prevInstance:DWORD,cmdlinePtr:DWORD,cmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL hWnd:HWND
LOCAL msg:MSG

 invoke MessageBox, NULL ,addr MsgBoxText, addr MsgCaption, MB_OK

 lea edi,wc
 sub eax,eax
 mov ecx,(sizeof WNDCLASSEX)/4
 rep stosd
 mov eax,hInst
 mov wc.hInstance,eax
 mov wc.cbSize, sizeof WNDCLASSEX
 mov wc.style,CS_OWNDC or CS_HREDRAW or CS_VREDRAW
 mov wc.lpszClassName,offset MyClassName
 mov wc.lpfnWndProc,offset MainWinProc
 invoke LoadCursor,NULL,IDC_ARROW
 mov wc.hCursor,eax
 mov wc.hbrBackground,COLOR_GRAYTEXT

 invoke RegisterClassEx,ADDR wc

 ;calcule de la taille de la fenetre
 invoke GetSystemMetrics,SM_CXSIZEFRAME
 lea ebx,[SCREEN_WIDTH+eax+eax]
 invoke GetSystemMetrics,SM_CYSIZEFRAME
 lea edi,[SCREEN_HEIGHT+eax+eax]
 invoke GetSystemMetrics,SM_CYCAPTION
 add edi,eax
 invoke GetSystemMetrics,SM_CYBORDER
 sub edi,eax
 inc edi ; !FIXME
;-----------------------------------------------------------------------------
; extended window style
; address of registered class name
; name for the window
; style
; pos X
; pos Y
; width
; height
; handle of parent or owner
; handle of menu
; hInstance
; ptr to window creation data
 sub eax,eax   ; EAX=NULL
 mov byte ptr [EscapePressed],al
 invoke CreateWindowEx,NULL,ADDR MyClassName,ADDR WinTitleString,WS_OVERLAPPEDWINDOW,16,16,ebx,edi,eax,eax,hInst,eax
 mov hWnd,eax
 push eax ; push hWnd for UpdateWindow
 invoke ShowWindow,eax,SW_SHOWDEFAULT
 call UpdateWindow  ; send WM_PAINT to the window proc
;-----------------------------------------------------------------------------

@@winmainmsgloop:    ;boucle prog<>thread
 sub eax,eax
 lea edi,msg
 invoke GetMessage,edi,eax,eax,eax
 test eax,eax
 jz @@quitmsgposted
 push edi
 push edi
 call TranslateMessage
 call DispatchMessage
 jmp @@winmainmsgloop
 EVEN
@@quitmsgposted:

Abort:
 invoke ExitProcess,eax

 ret
WinMain ENDP


Start:
 invoke GetModuleHandle,NULL 
 sub edx,edx
 invoke WinMain,eax,edx,edx,edx
END Start
